OPERATOR(l)={
    local(L=vector(l+3));
    [L[1],L[2]]=[1,Theta];
    for(k=1,l+1,L[k+2]=z*deriv(L[k+1],z)+Theta*L[k+1]-k*(l-k+2)*z*L[k]);
    L=(-1)^l*L[l+3];
    for(j=1,2,L=polcoef(L,0,z)/Theta+sum(k=1,poldegree(L,z),z^k*prod(i=1,k-1,Theta+i)*polcoef(L,k,z)));
    L=subst(L,Theta,Theta-1);
    (Theta-1)*L+z*deriv(L,z)
};

POINTCHANGE(L,p)={
    local(tmp=1,Lnew=0);
    if(p!=oo,for(k=0,poldegree(L,Theta),Lnew+=subst(polcoef(L,k,Theta),z,z+p)*tmp;tmp=(z+p)/z*(z*deriv(tmp,z)+tmp*Theta)),Lnew=subst(subst(L,Theta,-Theta),z,1/z));
    Lnew/z^(-poldegree(subst(Lnew,z,1/z),z))
};

INDICIALS(L)={
    L=factor(polcoef(L,0,z));
    vector(matsize(L)[1],X,[-polcoef(L[X,1],0,Theta)/polcoef(L[X,1],1,Theta),L[X,2]])
};

SOLVE(L,p,ord)={
    L=POINTCHANGE(L,p);
    local(rsl=[],rs=INDICIALS(L),f=[],fr,t=[],tr,Lg,disc,num,c);
    for(r=1,#rs,
        Lg=subst(L,Theta,Theta+rs[r][1]);
        fr=vector(rs[r][2]);
        fr[1]=1.0;
        for(k=1,ord-rs[r][1],for(X=1,rs[r][2],c=0;
            disc=subst(polcoef(Lg,0,z),Theta,k);
            if(disc==0&&X<rs[r][2],disc=subst(deriv(polcoef(Lg,0,z),Theta),Theta,k);if(disc!=0,c=1));
            if(disc!=0,fr[X]-=sum(i=0,min(poldegree(Lg,z),k),sum(j=1,X,subst(diffop(polcoef(Lg,i,z),[Theta],[1],j-1+c),Theta,k-i)/(j-1)!*polcoef(fr[X+1-j],k-i,z)))/disc*z^k)
        ));
        rsl=concat(rsl,vector(rs[r][2],i,rs[r][1]));
        tr=matrix(#fr,#fr,i,j,if(i<j,0,Log^(i-j)/(i-j)!));
        if(t==[],t=tr,t=matconcat(matdiagonal([t,tr])));
        f=concat(f,fr)
    );
    [rsl,t,f,if(p==oo,x->1/x,x->x-p)]
};

TRANSMAT(f1,f2,p)={
    local(n=#f1[3],A=B=matid(n),z1=f1[4],z2=f2[4]);
    A[,1]=f1[3]~;
    B[,1]=f2[3]~;
    for(i=2,n,A[,i]=deriv(A[,i-1],z);B[,i]=deriv(B[,i-1],z));
    A=matdiagonal(apply(x->z1(z+p+O(z^n))^x,f1[1]))*subst(f1[2],Log,log(z1(z+p+O(z^n))))*sum(i=0,n-1,subst(A[,i+1],z,z1(p))*(z1(z+p+O(z^n))-z1(p))^i/i!);
    B=matdiagonal(apply(x->z2(z+p+O(z^n))^x,f2[1]))*subst(f2[2],Log,log(z2(z+p+O(z^n))))*sum(i=0,n-1,subst(B[,i+1],z,z2(p))*(z2(z+p+O(z^n))-z2(p))^i/i!);
    matrix(n,n,X,Y,polcoef(A[X],Y-1,z))*matsolve(matrix(n,n,X,Y,polcoef(B[X],Y-1,z)),matid(n))
};

LAMBDAS(l)={
    local(g=exp(sum(k=2,l,zeta(k)*x^k/k)+O(x^(l+1))));
    g=-g/subst(g,x,-x)*exp(I*Pi*x+O(x^(l+1)));
    vector(l+1,k,(-1)^(k-1)*binomial(l+1,k-1)*polcoef(g,l-k+1,x)*(l-k+2)!*(k-1)!)
};

EVAL(f,t,zci,p)={
    if(#zci==0||p<=zci[1],p=f[1][4](p);t[1]*matdiagonal(apply(x->p^x,f[1][1]))*subst(f[1][2],Log,if(p==0,0,log(p)))*subst(f[1][3]~,z,p),EVAL(f[2..#f],t[2..#t],zci[2..#zci],p))
};

AMPLITUDE(l)={
    local(L=OPERATOR(l),ls=LAMBDAS(l),zi,ri,ai);my(f,t,zci);
    zi=concat([0],concat(vector(ceil((l+1)/2),j,1/(l+1-2*(j-1))^2),[oo]));
    ri=concat([zi[2]],concat(vector(#zi-3,i,min(zi[i+1]-zi[i],zi[i+2]-zi[i+1])),[zi[#zi-1]-zi[#zi-2],1/zi[#zi-1]]));
    zci=concat(vector(#zi-2,i,(ri[i]*zi[i+1]+ri[i+1]*zi[i])/(ri[i]+ri[i+1])),[zi[#zi-1]/2+sqrt(zi[#zi-1]^2/4+zi[#zi-1]*ri[#zi-1])]);
    ai=concat([1/2],concat(vector(#zi-2,i,max((zci[i]-zi[i])/ri[i],(zci[i+1]-zi[i+1])/ri[i+1])),[(zci[#zci]-zi[#zi-1])/ri[#ri-1]]));
    f=vector(#zi,i,SOLVE(L,zi[i],ceil((log(1-ai[i])-N*log(10))/log(ai[i]))));
    t=concat([matid(l+1)],vector(#zci,i,TRANSMAT(f[i],f[i+1],zci[i])));
    for(i=2,#t,t[i]=t[i-1]*t[i]);
    t=apply(x->ls*x,t);
    p->EVAL(f,t,zci,p)
};


\\------------------------------- Example -------------------------------

\p 60
N=60;

f=AMPLITUDE(4);

f(1)-8*Pi^2*lfun(lfunmf(mfinit([6,4],0),mffrometaquo([1,2;2,2;3,2;6,2])),2)
